<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" size="small">
      <template v-if="!checkRole(['entAdmin','entUser'])">
        <el-form-item label="省" prop="provinceId">
          <el-select v-model="queryParams.provinceId" placeholder="请选择省" @change="getCityData" filterable style="width: 200px;" clearable>
            <el-option v-for="(item,index) in provinceDataList" :key="index" :label="item.name" :value="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="市" prop="cityId">
          <el-select v-model="queryParams.cityId" placeholder="请选择市" @change="getDistrictData" filterable style="width: 200px;" clearable>
            <el-option v-for="(item, index) in cityDataList" :key="index" :label="item.name" :value="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="区" prop="districtId">
          <el-select v-model="queryParams.districtId" placeholder="请选择区" filterable style="width: 200px;" clearable>
            <el-option v-for="(item, index) in districtDataList" :key="index" :label="item.name" :value="item.id"></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="年份" prop="year">
          <el-date-picker
                type="years"
                v-model="years"
                placeholder="选择一个或多个年份" value-format="yyyy">
              </el-date-picker>
        </el-form-item>
        <el-form-item label="企业名称" prop="entName">
          <el-input v-model="queryParams.entName" clearable style="width: 200px;" placeholder="请填入企业名称"></el-input>
        </el-form-item>
        <el-form-item label="社会信用代码" prop="license">
          <el-input v-model="queryParams.license" style="width: 200px;" placeholder="请输入社会信用代码" clearable></el-input>
        </el-form-item>
      </template>
      <el-form-item label="项目编号" prop="projectNo">
        <el-input v-model="queryParams.projectNo" style="width: 200px;" placeholder="请输入项目编号" clearable></el-input>
      </el-form-item>
      <el-form-item label="项目名称" prop="projectName">
        <el-input v-model="queryParams.projectName" style="width: 200px;" placeholder="请输入项目名称" clearable></el-input>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" @click="handleQuery">搜索</el-button>
        <el-button @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>
    <h3 class="toolbar">
      <span class="title">列表</span>
      <div class="tool">
        <el-button type="text" style="color: red">当技术、财务资料达到 100%时，可提交项目申报</el-button>
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd" v-if="roleType == 'entAdmin' || roleType == 'entUser'">新增</el-button>
        <el-button type="primary" plain icon="el-icon-download" size="mini" @click="handleDownloadBatch">下载</el-button>
        <el-button type="primary" plain icon="el-icon-delete" size="mini" @click="handleBatchDel" v-if="roleType == 'entAdmin' || roleType == 'entUser' || roleType == 'manager'">批量删除</el-button>
      </div>
    </h3>
    <el-table v-loading="loading" :data="list" border @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="项目编号" prop="projectNo" width="150" align="center" />
      <el-table-column label="项目名称" prop="projectName" align="center" width="180"></el-table-column>
      <!-- <el-table-column label="企业名称" prop="entName" align="center" width="180"/> -->
      <!-- <el-table-column label="社会信用代码" prop="license" align="center" width="180" /> -->
      <el-table-column label="项目年份" prop="projectYear" align="center" width="120" />
      <el-table-column label="项目起止时间" align="center" width="200">
        <template slot-scope="scope">
          <span>{{scope.row.projectStartDate}} - {{scope.row.projectEndDate}}</span>
        </template>
      </el-table-column>
      <el-table-column label="创建时间" align="center" prop="createTime" width="160"></el-table-column>
      <el-table-column label="资料完善度" prop="linkEmail" align="center" width="340">
        <template slot-scope="scope">
          <span>企业 {{scope.row.entCompRate}} 技术 {{scope.row.techCompRate}} 财务 {{scope.row.finCompRate}}</span>
        </template>
      </el-table-column>
      <el-table-column label="负责状态" align="center" width="160">
        <template slot-scope="scope">
          <template v-if="scope.row.compRate !='100.0%'">
            <span>待完善</span>
          </template>
          <template v-if="scope.row.compRate =='100.0%' && scope.row.authState == '1'">
            <span>已完善</span>
          </template>
          <template v-if="scope.row.authState == '2'">
            <span>待审核</span>
          </template>
          <template v-if="scope.row.authState == '3'">
            <span>审核通过</span>
          </template>
          <template v-if="scope.row.authState == '4'">
            <span>审核拒绝</span>
          </template>
        </template>
      </el-table-column>
      </el-table-column>
      <el-table-column label="项目状态" prop="reportState" align="center" width="160" :formatter="reportStateFormat"></el-table-column>
      </el-table-column>
      <el-table-column label="操作" align="center" width="180" class-name="small-padding fixed-width" fixed="right">
        <template slot-scope="scope">
          <el-button type="text" @click="handleView(scope.row)">查看</el-button>
          <template v-if="scope.row.attachCnt != 0">
            <el-button type="text" @click="handleDownload(scope.row)">下载</el-button>
          </template>
          
          <template v-if="roleType == 'entAdmin' || roleType == 'entUser' || roleType == 'manager'">
            <el-button type="text" @click="handleEdit(scope.row)">编辑</el-button>
          </template>
          <template v-if="roleType == 'entAdmin' || roleType == 'entUser'">
            <el-button type="text" @click="handleDelete(scope.row)">删除</el-button>
            <template v-if="scope.row.finCompRate == '100.0%' && scope.row.reportState == '1'">
              <el-button type="text" @click="handleDeclare(scope.row)">提交申报</el-button>
            </template>
            <template v-if="scope.row.finCompRate == '100.0%' && (scope.row.reportState == '2' || scope.row.reportState == '3') ">
              <el-button type="text" @click="handleDeclare(scope.row)">重新申报</el-button>
            </template>
            <template v-if="scope.row.compRate == '100.0%' && (userType == 'ENT_TECH' || userType == 'ENT_FIN')">
              <!-- && (scope.row.authState == '1' || scope.row.authState == '4') -->
              <el-button type="text" @click="handleAudit(scope.row)" v-if="scope.row.authState == '1'">提交审核</el-button>
              <el-button type="text" @click="handleAudit(scope.row)" v-else-if="scope.row.authState == '4'">重新提交审核</el-button>
            </template>
            <template v-if="scope.row.authState == '2' && (userType == 'ENT_ADMIN_TECH' || userType == 'ENT_ADMIN_FIN')">
              <el-button type="text" @click="handleAuditAdmin(scope.row)">审核</el-button>
            </template>
          </template>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"/>
      <add-project v-if="addProjectVisible" ref="addProject" @refreshData="getList()"></add-project>
      <declare v-if="declareVisible" ref="declare" @refreshData="getList()"></declare>
      <audit-project v-if="auditVisible" ref="auditProject" @refreshData="getList()"></audit-project>
  </div>
</template>

<script>
  import {getProvinceDataApi,getRegionChildrenApi} from "@/api/common/common"
  import {listProjectApi, deleteEntApi, deleteProjectApi} from '@/api/enterprise/project/project'
  import {listProjectAdminApi} from '@/api/admin/project/project'
  import {entStateOptions, getLabel, authStateOptions, reportStateOptions} from '@/utils/dataFormat'
  import AddProject from './components/addProject'
  import declare from './components/declare'
  import {projectAuditApi} from '@/api/admin/project/project'
  import AuditProject from './components/audit'
  import {downloadProjectByIDApi} from '@/api/common/common'
  import { downLoadZip } from "@/utils/zipdownload";
  import { checkRole } from "@/utils/permission"; // 权限判断函数
  export default {
    components: {
      AddProject,
      declare,
      AuditProject
    },
    // ADMIN,GOV_PROV,GOV_CITY,GOV_DISTRI,ENT_ADMIN,ENT_TECH,ENT_ADMIN_TECH,ENT_FIN,ENT_ADMIN_FIN
    data () {
      return {
        years: [],
        loading: false,
        addProjectVisible: false,
        declareVisible: false,
        auditVisible: false,
        ids: [],
        selectCount: '',
        provinceDataList: [],
        cityDataList: [],
        districtDataList: [],
        entStateOptions: entStateOptions,
        authStateOptions: authStateOptions,
        // 模板状态
        // statusOptions: accessStatus,
        dateRange: [],
        queryParams: {
          pageNum: 1,
          pageSize: 10,
          provinceId: undefined,
          cityId: undefined,
          districtId: undefined,
          entName: '',
          year: '',
          license: '',
          projectNo: '',
          projectName: ''
        },
        list: [],
        total: 0,
        open: false,
        openInfo: false,
        roleType: '',
      }
    },
    computed: {
      userType() {
        return this.$store.state.user.userType
      },
      roles() {
        return this.$store.state.user.roles
      }
    },
    created() {
      this.getList()
      this.getProvinceData()
      this.roleType = this.roles.join(',')
    },
    methods: {
      checkRole,
      // 多选框选中数据
      handleSelectionChange(selection) {
        this.ids = selection.map(item => item.id)
        this.selectCount = selection.length;
      },
      handleBatchDel() {
        if(this.selectCount <= 0) {
          this.$message.error('请选择要删除的数据');
          return
        }
        const delIds = this.ids.join(',')
        this.$confirm('是否确认删除该数据?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            return deleteProjectApi(delIds);
          }).then(() => {
            this.queryParams.pageNum = 1;
            this.getList();
            this.$message({
              message: '删除成功',
              type: 'success'
            });
          })
      },
      //选择省份
      getCityData() {
        this.queryParams.cityId = ''
        this.queryParams.districtId = ''
        getRegionChildrenApi(this.queryParams.provinceId).then(res => {
          if(res.code == 200) {
            this.cityDataList = res.data
          }
        })
      },
      //选择市
      getDistrictData() {
        this.queryParams.districtId = ''
        getRegionChildrenApi(this.queryParams.cityId).then(res => {
          if(res.code == 200) {
            this.districtDataList = res.data
          }
        })
      },
      getProvinceData() {
        getProvinceDataApi().then(res => {
          if(res.code == 200) {
            this.provinceDataList = res.data
          }
        })
      },
      getList() {
        this.loading = true;
        this.queryParams.year = this.years.join(',')
        if(this.userType == 'ENT_ADMIN' || this.userType == 'ENT_TECH' || this.userType == 'ENT_ADMIN_TECH' || this.userType == 'ENT_FIN' || this.userType == 'ENT_ADMIN_FIN') {
          listProjectApi(this.queryParams).then(response => {
            this.list = response.data.records;
            this.total = response.data.total;
            this.loading = false;
          });
        }else if(this.userType == 'ADMIN') {
          listProjectAdminApi(this.queryParams).then(response => {
            this.list = response.data.records;
            this.total = response.data.total;
            this.loading = false;
          });
        }

      },
      handleAdd() {
        this.addProjectVisible = true
        this.$nextTick(() => {
          this.$refs.addProject.init()
        })
      },
      handleDownload(row) {
        downLoadZip('/project/download/' +row.id, "项目附件")
      },
      handleDownloadBatch() {
        if(this.selectCount <= 0) {
          this.$message.error('请选择要下载的项目');
          return
        }
        const delIds = this.ids.join(',')
        downLoadZip('/project/download/' +delIds, "项目附件")
      },
      handleDeclare(row) {
        this.declareVisible = true
        this.$nextTick(() => {
          this.$refs.declare.init(row.id)
        })
      },
      handleEdit(row) {
        this.$router.push({name: 'editProject', query: {id: row.id, entId: row.entId}})
      },
      // 审核
      handleAudit(row) {
        const projectId = row.id;
        const authState = '2'
        this.$confirm('是否确认提交审核该数据?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            return projectAuditApi(projectId,authState);
          }).then(() => {
            this.queryParams.pageNum = 1;
            this.getList();
            this.$message({
              message: '提交成功',
              type: 'success'
            });
          })
      },
      handleAuditAdmin(row) {
        this.auditVisible = true
        this.$nextTick(() => {
          this.$refs.auditProject.init(row.id)
        })
      },
      // 查看
      handleView(row) {
        this.$router.push("/project/info/"+row.id)
      },
      handleDelete(row) {
        const id = row.id;
        this.$confirm('是否确认删除该数据?', "警告", {
            confirmButtonText: "确定",
            cancelButtonText: "取消",
            type: "warning"
          }).then(function() {
            return deleteProjectApi(id);
          }).then(() => {
            this.queryParams.pageNum = 1;
            this.getList();
            this.$message({
              message: '删除成功',
              type: 'success'
            });
          })
      },
      // 重置
      resetQuery() {
        this.years = [];
        this.resetForm("queryForm");
        this.handleQuery();
      },
      // 搜索
      handleQuery() {
        this.queryParams.pageNum = 1;
        this.getList();
      },
      reportStateFormat(row, col, val, index) {
        return getLabel(reportStateOptions, val)
      }
    }
  }
</script>

<style>
</style>
